#ifndef APP_DLIST_H
#define APP_DLIST_H

#include <appclass.h>

/***************************************************************************
 *
 * DList(AppClass) Methods : A doubly linked list.
 *
 ***************************************************************************/

struct _DList {
    AppClass       parent;
    struct _DList *prev;
    struct _DList *next;
    AppClass      *data;
};


typedef struct _DList DList;

typedef int    (*DListFP_Cmp)        ( AppClass *d1, AppClass *d2 );
typedef int    (*DListFP_Iter)       ( AppClass *data, void *user_data);

extern DList    *dlist_add       ( DList *head, AppClass *data, DListFP_Cmp cmp, int *res );
extern DList    *dlist_add_head  ( DList *head, AppClass *data );
extern DList    *dlist_delete    ( DList *head, AppClass *data, DListFP_Cmp cmp );
extern void      dlist_delete_all( DList *head );
extern AppClass *dlist_lookup    ( DList *head, AppClass *data, DListFP_Cmp cmp );
extern DList    *dlist_iterator  ( DList *head, DListFP_Iter func, void *user_data );
extern int dlist_iterator_cmp    ( AppClass *n1, AppClass *n2 );
AppClass *dlist_get_ndata(DList *head, int n);

int dlist_get_nelem (DList *head );
extern int dlist_charPtr_cmp     ( AppClass *n1, AppClass *n2 );

#endif /* APP_DLIST_H */
